use LFPW, clear

capture program drop KS
program define KS
	version 6
	args todo b lnf

	tempvar theta sumG1 sumG2 G lnfj theta1
	tempname eta
	mleval `theta'=`b'
	
	quietly gen double `theta1'=0
	quietly gen double `sumG1'=0
	quietly gen double `sumG2'=0
	quietly gen double `G'=0

	local i=1
	while `i' <= _N {
		scalar `eta' = `theta'[`i'] + educ[`i']
		quietly replace `theta1'=`theta'
		quietly replace `theta1'=. if _n==`i'
		quietly replace `sumG1'=sum( $ML_y1 * normden((`eta'-`theta1'-educ)/.2) )
		quietly replace `sumG2'=sum( normden((`eta'-`theta1'-educ)/.2))
		quietly replace `G'=`sumG1'[_N]/`sumG2'[_N] if _n==`i'
		*list `G'
		local i=`i'+1
	}
	di "(E)"

	quietly gen double `lnfj'=ln(`G')  if $ML_y1==1 & `G'>0
	quietly replace    `lnfj'=ln(.000001) if $ML_y1==1 & `G'<=0
	quietly replace    `lnfj'=ln(1-`G') if $ML_y1==0 & `G'<=1
	quietly replace    `lnfj'=ln(.999999) if $ML_y1==0 & `G'>1
	mlsum `lnf' = `lnfj'
end

ml model d0 KS (LFP = EXP EXP2 BLACK HISPANIC KIDSLT6 KIDS618 LINC HHI NC, nocons)
ml init  EXP=1.097 EXP2=-0.403 BLACK=0.402 HISPANIC=-0.691 KIDSLT6=-1.096 KIDS618=-.316 LINC=-0.145 HHI=-0.73 NC=0.396
ml maximize, trace




